package xtext.workshop.advanced.parser.antlr.internal; 

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.xtext.parsetree.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.xtext.conversion.ValueConverterException;
import xtext.workshop.advanced.services.TouristguideDslGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalTouristguideDslParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_STRING", "RULE_ID", "RULE_INT", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'city'", "'{'", "'}'", "'sight'"
    };
    public static final int RULE_ID=5;
    public static final int RULE_STRING=4;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=6;
    public static final int RULE_WS=9;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;

        public InternalTouristguideDslParser(TokenStream input) {
            super(input);
        }
        

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g"; }



     	private TouristguideDslGrammarAccess grammarAccess;
     	
        public InternalTouristguideDslParser(TokenStream input, IAstFactory factory, TouristguideDslGrammarAccess grammarAccess) {
            this(input);
            this.factory = factory;
            registerRules(grammarAccess.getGrammar());
            this.grammarAccess = grammarAccess;
        }
        
        @Override
        protected InputStream getTokenFile() {
        	ClassLoader classLoader = getClass().getClassLoader();
        	return classLoader.getResourceAsStream("xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.tokens");
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "Model";	
       	}
       	
       	@Override
       	protected TouristguideDslGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start entryRuleModel
    // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:77:1: entryRuleModel returns [EObject current=null] : iv_ruleModel= ruleModel EOF ;
    public final EObject entryRuleModel() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleModel = null;


        try {
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:78:2: (iv_ruleModel= ruleModel EOF )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:79:2: iv_ruleModel= ruleModel EOF
            {
             currentNode = createCompositeNode(grammarAccess.getModelRule(), currentNode); 
            pushFollow(FOLLOW_ruleModel_in_entryRuleModel75);
            iv_ruleModel=ruleModel();
            _fsp--;

             current =iv_ruleModel; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleModel85); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end entryRuleModel


    // $ANTLR start ruleModel
    // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:86:1: ruleModel returns [EObject current=null] : ( (lv_cities_0_0= ruleCity ) )* ;
    public final EObject ruleModel() throws RecognitionException {
        EObject current = null;

        EObject lv_cities_0_0 = null;


         EObject temp=null; setCurrentLookahead(); resetLookahead(); 
            
        try {
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:91:6: ( ( (lv_cities_0_0= ruleCity ) )* )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:92:1: ( (lv_cities_0_0= ruleCity ) )*
            {
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:92:1: ( (lv_cities_0_0= ruleCity ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==11) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:93:1: (lv_cities_0_0= ruleCity )
            	    {
            	    // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:93:1: (lv_cities_0_0= ruleCity )
            	    // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:94:3: lv_cities_0_0= ruleCity
            	    {
            	     
            	    	        currentNode=createCompositeNode(grammarAccess.getModelAccess().getCitiesCityParserRuleCall_0(), currentNode); 
            	    	    
            	    pushFollow(FOLLOW_ruleCity_in_ruleModel130);
            	    lv_cities_0_0=ruleCity();
            	    _fsp--;


            	    	        if (current==null) {
            	    	            current = factory.create(grammarAccess.getModelRule().getType().getClassifier());
            	    	            associateNodeWithAstElement(currentNode.getParent(), current);
            	    	        }
            	    	        try {
            	    	       		add(
            	    	       			current, 
            	    	       			"cities",
            	    	        		lv_cities_0_0, 
            	    	        		"City", 
            	    	        		currentNode);
            	    	        } catch (ValueConverterException vce) {
            	    				handleValueConverterException(vce);
            	    	        }
            	    	        currentNode = currentNode.getParent();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }

             resetLookahead(); 
                	lastConsumedNode = currentNode;
                
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end ruleModel


    // $ANTLR start entryRuleCity
    // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:124:1: entryRuleCity returns [EObject current=null] : iv_ruleCity= ruleCity EOF ;
    public final EObject entryRuleCity() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleCity = null;


        try {
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:125:2: (iv_ruleCity= ruleCity EOF )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:126:2: iv_ruleCity= ruleCity EOF
            {
             currentNode = createCompositeNode(grammarAccess.getCityRule(), currentNode); 
            pushFollow(FOLLOW_ruleCity_in_entryRuleCity166);
            iv_ruleCity=ruleCity();
            _fsp--;

             current =iv_ruleCity; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleCity176); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end entryRuleCity


    // $ANTLR start ruleCity
    // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:133:1: ruleCity returns [EObject current=null] : ( 'city' ( (lv_name_1_0= RULE_STRING ) ) '{' ( (lv_sights_3_0= ruleSight ) )* '}' ) ;
    public final EObject ruleCity() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;
        EObject lv_sights_3_0 = null;


         EObject temp=null; setCurrentLookahead(); resetLookahead(); 
            
        try {
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:138:6: ( ( 'city' ( (lv_name_1_0= RULE_STRING ) ) '{' ( (lv_sights_3_0= ruleSight ) )* '}' ) )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:139:1: ( 'city' ( (lv_name_1_0= RULE_STRING ) ) '{' ( (lv_sights_3_0= ruleSight ) )* '}' )
            {
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:139:1: ( 'city' ( (lv_name_1_0= RULE_STRING ) ) '{' ( (lv_sights_3_0= ruleSight ) )* '}' )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:139:3: 'city' ( (lv_name_1_0= RULE_STRING ) ) '{' ( (lv_sights_3_0= ruleSight ) )* '}'
            {
            match(input,11,FOLLOW_11_in_ruleCity211); 

                    createLeafNode(grammarAccess.getCityAccess().getCityKeyword_0(), null); 
                
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:143:1: ( (lv_name_1_0= RULE_STRING ) )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:144:1: (lv_name_1_0= RULE_STRING )
            {
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:144:1: (lv_name_1_0= RULE_STRING )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:145:3: lv_name_1_0= RULE_STRING
            {
            lv_name_1_0=(Token)input.LT(1);
            match(input,RULE_STRING,FOLLOW_RULE_STRING_in_ruleCity228); 

            			createLeafNode(grammarAccess.getCityAccess().getNameSTRINGTerminalRuleCall_1_0(), "name"); 
            		

            	        if (current==null) {
            	            current = factory.create(grammarAccess.getCityRule().getType().getClassifier());
            	            associateNodeWithAstElement(currentNode, current);
            	        }
            	        try {
            	       		set(
            	       			current, 
            	       			"name",
            	        		lv_name_1_0, 
            	        		"STRING", 
            	        		lastConsumedNode);
            	        } catch (ValueConverterException vce) {
            				handleValueConverterException(vce);
            	        }
            	    

            }


            }

            match(input,12,FOLLOW_12_in_ruleCity243); 

                    createLeafNode(grammarAccess.getCityAccess().getLeftCurlyBracketKeyword_2(), null); 
                
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:171:1: ( (lv_sights_3_0= ruleSight ) )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==14) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:172:1: (lv_sights_3_0= ruleSight )
            	    {
            	    // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:172:1: (lv_sights_3_0= ruleSight )
            	    // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:173:3: lv_sights_3_0= ruleSight
            	    {
            	     
            	    	        currentNode=createCompositeNode(grammarAccess.getCityAccess().getSightsSightParserRuleCall_3_0(), currentNode); 
            	    	    
            	    pushFollow(FOLLOW_ruleSight_in_ruleCity264);
            	    lv_sights_3_0=ruleSight();
            	    _fsp--;


            	    	        if (current==null) {
            	    	            current = factory.create(grammarAccess.getCityRule().getType().getClassifier());
            	    	            associateNodeWithAstElement(currentNode.getParent(), current);
            	    	        }
            	    	        try {
            	    	       		add(
            	    	       			current, 
            	    	       			"sights",
            	    	        		lv_sights_3_0, 
            	    	        		"Sight", 
            	    	        		currentNode);
            	    	        } catch (ValueConverterException vce) {
            	    				handleValueConverterException(vce);
            	    	        }
            	    	        currentNode = currentNode.getParent();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            match(input,13,FOLLOW_13_in_ruleCity275); 

                    createLeafNode(grammarAccess.getCityAccess().getRightCurlyBracketKeyword_4(), null); 
                

            }


            }

             resetLookahead(); 
                	lastConsumedNode = currentNode;
                
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end ruleCity


    // $ANTLR start entryRuleSight
    // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:207:1: entryRuleSight returns [EObject current=null] : iv_ruleSight= ruleSight EOF ;
    public final EObject entryRuleSight() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSight = null;


        try {
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:208:2: (iv_ruleSight= ruleSight EOF )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:209:2: iv_ruleSight= ruleSight EOF
            {
             currentNode = createCompositeNode(grammarAccess.getSightRule(), currentNode); 
            pushFollow(FOLLOW_ruleSight_in_entryRuleSight311);
            iv_ruleSight=ruleSight();
            _fsp--;

             current =iv_ruleSight; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleSight321); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end entryRuleSight


    // $ANTLR start ruleSight
    // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:216:1: ruleSight returns [EObject current=null] : ( 'sight' ( (lv_name_1_0= RULE_STRING ) ) ( (lv_description_2_0= RULE_STRING ) ) ) ;
    public final EObject ruleSight() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;
        Token lv_description_2_0=null;

         EObject temp=null; setCurrentLookahead(); resetLookahead(); 
            
        try {
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:221:6: ( ( 'sight' ( (lv_name_1_0= RULE_STRING ) ) ( (lv_description_2_0= RULE_STRING ) ) ) )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:222:1: ( 'sight' ( (lv_name_1_0= RULE_STRING ) ) ( (lv_description_2_0= RULE_STRING ) ) )
            {
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:222:1: ( 'sight' ( (lv_name_1_0= RULE_STRING ) ) ( (lv_description_2_0= RULE_STRING ) ) )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:222:3: 'sight' ( (lv_name_1_0= RULE_STRING ) ) ( (lv_description_2_0= RULE_STRING ) )
            {
            match(input,14,FOLLOW_14_in_ruleSight356); 

                    createLeafNode(grammarAccess.getSightAccess().getSightKeyword_0(), null); 
                
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:226:1: ( (lv_name_1_0= RULE_STRING ) )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:227:1: (lv_name_1_0= RULE_STRING )
            {
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:227:1: (lv_name_1_0= RULE_STRING )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:228:3: lv_name_1_0= RULE_STRING
            {
            lv_name_1_0=(Token)input.LT(1);
            match(input,RULE_STRING,FOLLOW_RULE_STRING_in_ruleSight373); 

            			createLeafNode(grammarAccess.getSightAccess().getNameSTRINGTerminalRuleCall_1_0(), "name"); 
            		

            	        if (current==null) {
            	            current = factory.create(grammarAccess.getSightRule().getType().getClassifier());
            	            associateNodeWithAstElement(currentNode, current);
            	        }
            	        try {
            	       		set(
            	       			current, 
            	       			"name",
            	        		lv_name_1_0, 
            	        		"STRING", 
            	        		lastConsumedNode);
            	        } catch (ValueConverterException vce) {
            				handleValueConverterException(vce);
            	        }
            	    

            }


            }

            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:250:2: ( (lv_description_2_0= RULE_STRING ) )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:251:1: (lv_description_2_0= RULE_STRING )
            {
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:251:1: (lv_description_2_0= RULE_STRING )
            // ../xtext.workshop.advanced.quickfix/src-gen/xtext/workshop/advanced/parser/antlr/internal/InternalTouristguideDsl.g:252:3: lv_description_2_0= RULE_STRING
            {
            lv_description_2_0=(Token)input.LT(1);
            match(input,RULE_STRING,FOLLOW_RULE_STRING_in_ruleSight395); 

            			createLeafNode(grammarAccess.getSightAccess().getDescriptionSTRINGTerminalRuleCall_2_0(), "description"); 
            		

            	        if (current==null) {
            	            current = factory.create(grammarAccess.getSightRule().getType().getClassifier());
            	            associateNodeWithAstElement(currentNode, current);
            	        }
            	        try {
            	       		set(
            	       			current, 
            	       			"description",
            	        		lv_description_2_0, 
            	        		"STRING", 
            	        		lastConsumedNode);
            	        } catch (ValueConverterException vce) {
            				handleValueConverterException(vce);
            	        }
            	    

            }


            }


            }


            }

             resetLookahead(); 
                	lastConsumedNode = currentNode;
                
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end ruleSight


 

    public static final BitSet FOLLOW_ruleModel_in_entryRuleModel75 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleModel85 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCity_in_ruleModel130 = new BitSet(new long[]{0x0000000000000802L});
    public static final BitSet FOLLOW_ruleCity_in_entryRuleCity166 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleCity176 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_ruleCity211 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_STRING_in_ruleCity228 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleCity243 = new BitSet(new long[]{0x0000000000006000L});
    public static final BitSet FOLLOW_ruleSight_in_ruleCity264 = new BitSet(new long[]{0x0000000000006000L});
    public static final BitSet FOLLOW_13_in_ruleCity275 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleSight_in_entryRuleSight311 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleSight321 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_14_in_ruleSight356 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_STRING_in_ruleSight373 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_STRING_in_ruleSight395 = new BitSet(new long[]{0x0000000000000002L});

}