package xtext.workshop.advanced.ui.contentassist.antlr.internal; 

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.xtext.parsetree.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.DFA;
import xtext.workshop.advanced.services.TouristguideDslGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalTouristguideDslParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_STRING", "RULE_ID", "RULE_INT", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'city'", "'{'", "'}'", "'sight'"
    };
    public static final int RULE_ID=5;
    public static final int RULE_STRING=4;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=6;
    public static final int RULE_WS=9;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;

        public InternalTouristguideDslParser(TokenStream input) {
            super(input);
        }
        

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g"; }


     
     	private TouristguideDslGrammarAccess grammarAccess;
     	
        public void setGrammarAccess(TouristguideDslGrammarAccess grammarAccess) {
        	this.grammarAccess = grammarAccess;
        }
        
        @Override
        protected Grammar getGrammar() {
        	return grammarAccess.getGrammar();
        }
        
        @Override
        protected String getValueForTokenName(String tokenName) {
        	return tokenName;
        }




    // $ANTLR start entryRuleModel
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:61:1: entryRuleModel : ruleModel EOF ;
    public final void entryRuleModel() throws RecognitionException {
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:62:1: ( ruleModel EOF )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:63:1: ruleModel EOF
            {
             before(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_ruleModel_in_entryRuleModel61);
            ruleModel();
            _fsp--;

             after(grammarAccess.getModelRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleModel68); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end entryRuleModel


    // $ANTLR start ruleModel
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:70:1: ruleModel : ( ( rule__Model__CitiesAssignment )* ) ;
    public final void ruleModel() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:74:2: ( ( ( rule__Model__CitiesAssignment )* ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:75:1: ( ( rule__Model__CitiesAssignment )* )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:75:1: ( ( rule__Model__CitiesAssignment )* )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:76:1: ( rule__Model__CitiesAssignment )*
            {
             before(grammarAccess.getModelAccess().getCitiesAssignment()); 
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:77:1: ( rule__Model__CitiesAssignment )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==11) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:77:2: rule__Model__CitiesAssignment
            	    {
            	    pushFollow(FOLLOW_rule__Model__CitiesAssignment_in_ruleModel94);
            	    rule__Model__CitiesAssignment();
            	    _fsp--;


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

             after(grammarAccess.getModelAccess().getCitiesAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end ruleModel


    // $ANTLR start entryRuleCity
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:89:1: entryRuleCity : ruleCity EOF ;
    public final void entryRuleCity() throws RecognitionException {
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:90:1: ( ruleCity EOF )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:91:1: ruleCity EOF
            {
             before(grammarAccess.getCityRule()); 
            pushFollow(FOLLOW_ruleCity_in_entryRuleCity122);
            ruleCity();
            _fsp--;

             after(grammarAccess.getCityRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleCity129); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end entryRuleCity


    // $ANTLR start ruleCity
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:98:1: ruleCity : ( ( rule__City__Group__0 ) ) ;
    public final void ruleCity() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:102:2: ( ( ( rule__City__Group__0 ) ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:103:1: ( ( rule__City__Group__0 ) )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:103:1: ( ( rule__City__Group__0 ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:104:1: ( rule__City__Group__0 )
            {
             before(grammarAccess.getCityAccess().getGroup()); 
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:105:1: ( rule__City__Group__0 )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:105:2: rule__City__Group__0
            {
            pushFollow(FOLLOW_rule__City__Group__0_in_ruleCity155);
            rule__City__Group__0();
            _fsp--;


            }

             after(grammarAccess.getCityAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end ruleCity


    // $ANTLR start entryRuleSight
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:117:1: entryRuleSight : ruleSight EOF ;
    public final void entryRuleSight() throws RecognitionException {
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:118:1: ( ruleSight EOF )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:119:1: ruleSight EOF
            {
             before(grammarAccess.getSightRule()); 
            pushFollow(FOLLOW_ruleSight_in_entryRuleSight182);
            ruleSight();
            _fsp--;

             after(grammarAccess.getSightRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleSight189); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end entryRuleSight


    // $ANTLR start ruleSight
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:126:1: ruleSight : ( ( rule__Sight__Group__0 ) ) ;
    public final void ruleSight() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:130:2: ( ( ( rule__Sight__Group__0 ) ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:131:1: ( ( rule__Sight__Group__0 ) )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:131:1: ( ( rule__Sight__Group__0 ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:132:1: ( rule__Sight__Group__0 )
            {
             before(grammarAccess.getSightAccess().getGroup()); 
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:133:1: ( rule__Sight__Group__0 )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:133:2: rule__Sight__Group__0
            {
            pushFollow(FOLLOW_rule__Sight__Group__0_in_ruleSight215);
            rule__Sight__Group__0();
            _fsp--;


            }

             after(grammarAccess.getSightAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end ruleSight


    // $ANTLR start rule__City__Group__0
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:147:1: rule__City__Group__0 : rule__City__Group__0__Impl rule__City__Group__1 ;
    public final void rule__City__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:151:1: ( rule__City__Group__0__Impl rule__City__Group__1 )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:152:2: rule__City__Group__0__Impl rule__City__Group__1
            {
            pushFollow(FOLLOW_rule__City__Group__0__Impl_in_rule__City__Group__0249);
            rule__City__Group__0__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__City__Group__1_in_rule__City__Group__0252);
            rule__City__Group__1();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__City__Group__0


    // $ANTLR start rule__City__Group__0__Impl
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:159:1: rule__City__Group__0__Impl : ( 'city' ) ;
    public final void rule__City__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:163:1: ( ( 'city' ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:164:1: ( 'city' )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:164:1: ( 'city' )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:165:1: 'city'
            {
             before(grammarAccess.getCityAccess().getCityKeyword_0()); 
            match(input,11,FOLLOW_11_in_rule__City__Group__0__Impl280); 
             after(grammarAccess.getCityAccess().getCityKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__City__Group__0__Impl


    // $ANTLR start rule__City__Group__1
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:178:1: rule__City__Group__1 : rule__City__Group__1__Impl rule__City__Group__2 ;
    public final void rule__City__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:182:1: ( rule__City__Group__1__Impl rule__City__Group__2 )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:183:2: rule__City__Group__1__Impl rule__City__Group__2
            {
            pushFollow(FOLLOW_rule__City__Group__1__Impl_in_rule__City__Group__1311);
            rule__City__Group__1__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__City__Group__2_in_rule__City__Group__1314);
            rule__City__Group__2();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__City__Group__1


    // $ANTLR start rule__City__Group__1__Impl
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:190:1: rule__City__Group__1__Impl : ( ( rule__City__NameAssignment_1 ) ) ;
    public final void rule__City__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:194:1: ( ( ( rule__City__NameAssignment_1 ) ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:195:1: ( ( rule__City__NameAssignment_1 ) )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:195:1: ( ( rule__City__NameAssignment_1 ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:196:1: ( rule__City__NameAssignment_1 )
            {
             before(grammarAccess.getCityAccess().getNameAssignment_1()); 
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:197:1: ( rule__City__NameAssignment_1 )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:197:2: rule__City__NameAssignment_1
            {
            pushFollow(FOLLOW_rule__City__NameAssignment_1_in_rule__City__Group__1__Impl341);
            rule__City__NameAssignment_1();
            _fsp--;


            }

             after(grammarAccess.getCityAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__City__Group__1__Impl


    // $ANTLR start rule__City__Group__2
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:207:1: rule__City__Group__2 : rule__City__Group__2__Impl rule__City__Group__3 ;
    public final void rule__City__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:211:1: ( rule__City__Group__2__Impl rule__City__Group__3 )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:212:2: rule__City__Group__2__Impl rule__City__Group__3
            {
            pushFollow(FOLLOW_rule__City__Group__2__Impl_in_rule__City__Group__2371);
            rule__City__Group__2__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__City__Group__3_in_rule__City__Group__2374);
            rule__City__Group__3();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__City__Group__2


    // $ANTLR start rule__City__Group__2__Impl
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:219:1: rule__City__Group__2__Impl : ( '{' ) ;
    public final void rule__City__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:223:1: ( ( '{' ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:224:1: ( '{' )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:224:1: ( '{' )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:225:1: '{'
            {
             before(grammarAccess.getCityAccess().getLeftCurlyBracketKeyword_2()); 
            match(input,12,FOLLOW_12_in_rule__City__Group__2__Impl402); 
             after(grammarAccess.getCityAccess().getLeftCurlyBracketKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__City__Group__2__Impl


    // $ANTLR start rule__City__Group__3
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:238:1: rule__City__Group__3 : rule__City__Group__3__Impl rule__City__Group__4 ;
    public final void rule__City__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:242:1: ( rule__City__Group__3__Impl rule__City__Group__4 )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:243:2: rule__City__Group__3__Impl rule__City__Group__4
            {
            pushFollow(FOLLOW_rule__City__Group__3__Impl_in_rule__City__Group__3433);
            rule__City__Group__3__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__City__Group__4_in_rule__City__Group__3436);
            rule__City__Group__4();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__City__Group__3


    // $ANTLR start rule__City__Group__3__Impl
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:250:1: rule__City__Group__3__Impl : ( ( rule__City__SightsAssignment_3 )* ) ;
    public final void rule__City__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:254:1: ( ( ( rule__City__SightsAssignment_3 )* ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:255:1: ( ( rule__City__SightsAssignment_3 )* )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:255:1: ( ( rule__City__SightsAssignment_3 )* )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:256:1: ( rule__City__SightsAssignment_3 )*
            {
             before(grammarAccess.getCityAccess().getSightsAssignment_3()); 
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:257:1: ( rule__City__SightsAssignment_3 )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==14) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:257:2: rule__City__SightsAssignment_3
            	    {
            	    pushFollow(FOLLOW_rule__City__SightsAssignment_3_in_rule__City__Group__3__Impl463);
            	    rule__City__SightsAssignment_3();
            	    _fsp--;


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

             after(grammarAccess.getCityAccess().getSightsAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__City__Group__3__Impl


    // $ANTLR start rule__City__Group__4
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:267:1: rule__City__Group__4 : rule__City__Group__4__Impl ;
    public final void rule__City__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:271:1: ( rule__City__Group__4__Impl )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:272:2: rule__City__Group__4__Impl
            {
            pushFollow(FOLLOW_rule__City__Group__4__Impl_in_rule__City__Group__4494);
            rule__City__Group__4__Impl();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__City__Group__4


    // $ANTLR start rule__City__Group__4__Impl
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:278:1: rule__City__Group__4__Impl : ( '}' ) ;
    public final void rule__City__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:282:1: ( ( '}' ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:283:1: ( '}' )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:283:1: ( '}' )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:284:1: '}'
            {
             before(grammarAccess.getCityAccess().getRightCurlyBracketKeyword_4()); 
            match(input,13,FOLLOW_13_in_rule__City__Group__4__Impl522); 
             after(grammarAccess.getCityAccess().getRightCurlyBracketKeyword_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__City__Group__4__Impl


    // $ANTLR start rule__Sight__Group__0
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:307:1: rule__Sight__Group__0 : rule__Sight__Group__0__Impl rule__Sight__Group__1 ;
    public final void rule__Sight__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:311:1: ( rule__Sight__Group__0__Impl rule__Sight__Group__1 )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:312:2: rule__Sight__Group__0__Impl rule__Sight__Group__1
            {
            pushFollow(FOLLOW_rule__Sight__Group__0__Impl_in_rule__Sight__Group__0563);
            rule__Sight__Group__0__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Sight__Group__1_in_rule__Sight__Group__0566);
            rule__Sight__Group__1();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Sight__Group__0


    // $ANTLR start rule__Sight__Group__0__Impl
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:319:1: rule__Sight__Group__0__Impl : ( 'sight' ) ;
    public final void rule__Sight__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:323:1: ( ( 'sight' ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:324:1: ( 'sight' )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:324:1: ( 'sight' )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:325:1: 'sight'
            {
             before(grammarAccess.getSightAccess().getSightKeyword_0()); 
            match(input,14,FOLLOW_14_in_rule__Sight__Group__0__Impl594); 
             after(grammarAccess.getSightAccess().getSightKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Sight__Group__0__Impl


    // $ANTLR start rule__Sight__Group__1
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:338:1: rule__Sight__Group__1 : rule__Sight__Group__1__Impl rule__Sight__Group__2 ;
    public final void rule__Sight__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:342:1: ( rule__Sight__Group__1__Impl rule__Sight__Group__2 )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:343:2: rule__Sight__Group__1__Impl rule__Sight__Group__2
            {
            pushFollow(FOLLOW_rule__Sight__Group__1__Impl_in_rule__Sight__Group__1625);
            rule__Sight__Group__1__Impl();
            _fsp--;

            pushFollow(FOLLOW_rule__Sight__Group__2_in_rule__Sight__Group__1628);
            rule__Sight__Group__2();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Sight__Group__1


    // $ANTLR start rule__Sight__Group__1__Impl
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:350:1: rule__Sight__Group__1__Impl : ( ( rule__Sight__NameAssignment_1 ) ) ;
    public final void rule__Sight__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:354:1: ( ( ( rule__Sight__NameAssignment_1 ) ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:355:1: ( ( rule__Sight__NameAssignment_1 ) )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:355:1: ( ( rule__Sight__NameAssignment_1 ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:356:1: ( rule__Sight__NameAssignment_1 )
            {
             before(grammarAccess.getSightAccess().getNameAssignment_1()); 
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:357:1: ( rule__Sight__NameAssignment_1 )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:357:2: rule__Sight__NameAssignment_1
            {
            pushFollow(FOLLOW_rule__Sight__NameAssignment_1_in_rule__Sight__Group__1__Impl655);
            rule__Sight__NameAssignment_1();
            _fsp--;


            }

             after(grammarAccess.getSightAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Sight__Group__1__Impl


    // $ANTLR start rule__Sight__Group__2
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:367:1: rule__Sight__Group__2 : rule__Sight__Group__2__Impl ;
    public final void rule__Sight__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:371:1: ( rule__Sight__Group__2__Impl )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:372:2: rule__Sight__Group__2__Impl
            {
            pushFollow(FOLLOW_rule__Sight__Group__2__Impl_in_rule__Sight__Group__2685);
            rule__Sight__Group__2__Impl();
            _fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Sight__Group__2


    // $ANTLR start rule__Sight__Group__2__Impl
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:378:1: rule__Sight__Group__2__Impl : ( ( rule__Sight__DescriptionAssignment_2 ) ) ;
    public final void rule__Sight__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:382:1: ( ( ( rule__Sight__DescriptionAssignment_2 ) ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:383:1: ( ( rule__Sight__DescriptionAssignment_2 ) )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:383:1: ( ( rule__Sight__DescriptionAssignment_2 ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:384:1: ( rule__Sight__DescriptionAssignment_2 )
            {
             before(grammarAccess.getSightAccess().getDescriptionAssignment_2()); 
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:385:1: ( rule__Sight__DescriptionAssignment_2 )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:385:2: rule__Sight__DescriptionAssignment_2
            {
            pushFollow(FOLLOW_rule__Sight__DescriptionAssignment_2_in_rule__Sight__Group__2__Impl712);
            rule__Sight__DescriptionAssignment_2();
            _fsp--;


            }

             after(grammarAccess.getSightAccess().getDescriptionAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Sight__Group__2__Impl


    // $ANTLR start rule__Model__CitiesAssignment
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:402:1: rule__Model__CitiesAssignment : ( ruleCity ) ;
    public final void rule__Model__CitiesAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:406:1: ( ( ruleCity ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:407:1: ( ruleCity )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:407:1: ( ruleCity )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:408:1: ruleCity
            {
             before(grammarAccess.getModelAccess().getCitiesCityParserRuleCall_0()); 
            pushFollow(FOLLOW_ruleCity_in_rule__Model__CitiesAssignment753);
            ruleCity();
            _fsp--;

             after(grammarAccess.getModelAccess().getCitiesCityParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Model__CitiesAssignment


    // $ANTLR start rule__City__NameAssignment_1
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:417:1: rule__City__NameAssignment_1 : ( RULE_STRING ) ;
    public final void rule__City__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:421:1: ( ( RULE_STRING ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:422:1: ( RULE_STRING )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:422:1: ( RULE_STRING )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:423:1: RULE_STRING
            {
             before(grammarAccess.getCityAccess().getNameSTRINGTerminalRuleCall_1_0()); 
            match(input,RULE_STRING,FOLLOW_RULE_STRING_in_rule__City__NameAssignment_1784); 
             after(grammarAccess.getCityAccess().getNameSTRINGTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__City__NameAssignment_1


    // $ANTLR start rule__City__SightsAssignment_3
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:432:1: rule__City__SightsAssignment_3 : ( ruleSight ) ;
    public final void rule__City__SightsAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:436:1: ( ( ruleSight ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:437:1: ( ruleSight )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:437:1: ( ruleSight )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:438:1: ruleSight
            {
             before(grammarAccess.getCityAccess().getSightsSightParserRuleCall_3_0()); 
            pushFollow(FOLLOW_ruleSight_in_rule__City__SightsAssignment_3815);
            ruleSight();
            _fsp--;

             after(grammarAccess.getCityAccess().getSightsSightParserRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__City__SightsAssignment_3


    // $ANTLR start rule__Sight__NameAssignment_1
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:447:1: rule__Sight__NameAssignment_1 : ( RULE_STRING ) ;
    public final void rule__Sight__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:451:1: ( ( RULE_STRING ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:452:1: ( RULE_STRING )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:452:1: ( RULE_STRING )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:453:1: RULE_STRING
            {
             before(grammarAccess.getSightAccess().getNameSTRINGTerminalRuleCall_1_0()); 
            match(input,RULE_STRING,FOLLOW_RULE_STRING_in_rule__Sight__NameAssignment_1846); 
             after(grammarAccess.getSightAccess().getNameSTRINGTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Sight__NameAssignment_1


    // $ANTLR start rule__Sight__DescriptionAssignment_2
    // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:462:1: rule__Sight__DescriptionAssignment_2 : ( RULE_STRING ) ;
    public final void rule__Sight__DescriptionAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:466:1: ( ( RULE_STRING ) )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:467:1: ( RULE_STRING )
            {
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:467:1: ( RULE_STRING )
            // ../xtext.workshop.advanced.quickfix.ui/src-gen/xtext/workshop/advanced/ui/contentassist/antlr/internal/InternalTouristguideDsl.g:468:1: RULE_STRING
            {
             before(grammarAccess.getSightAccess().getDescriptionSTRINGTerminalRuleCall_2_0()); 
            match(input,RULE_STRING,FOLLOW_RULE_STRING_in_rule__Sight__DescriptionAssignment_2877); 
             after(grammarAccess.getSightAccess().getDescriptionSTRINGTerminalRuleCall_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end rule__Sight__DescriptionAssignment_2


 

    public static final BitSet FOLLOW_ruleModel_in_entryRuleModel61 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleModel68 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Model__CitiesAssignment_in_ruleModel94 = new BitSet(new long[]{0x0000000000000802L});
    public static final BitSet FOLLOW_ruleCity_in_entryRuleCity122 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleCity129 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__City__Group__0_in_ruleCity155 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleSight_in_entryRuleSight182 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleSight189 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Sight__Group__0_in_ruleSight215 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__City__Group__0__Impl_in_rule__City__Group__0249 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__City__Group__1_in_rule__City__Group__0252 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_rule__City__Group__0__Impl280 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__City__Group__1__Impl_in_rule__City__Group__1311 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_rule__City__Group__2_in_rule__City__Group__1314 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__City__NameAssignment_1_in_rule__City__Group__1__Impl341 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__City__Group__2__Impl_in_rule__City__Group__2371 = new BitSet(new long[]{0x0000000000006000L});
    public static final BitSet FOLLOW_rule__City__Group__3_in_rule__City__Group__2374 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_12_in_rule__City__Group__2__Impl402 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__City__Group__3__Impl_in_rule__City__Group__3433 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_rule__City__Group__4_in_rule__City__Group__3436 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__City__SightsAssignment_3_in_rule__City__Group__3__Impl463 = new BitSet(new long[]{0x0000000000004002L});
    public static final BitSet FOLLOW_rule__City__Group__4__Impl_in_rule__City__Group__4494 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_13_in_rule__City__Group__4__Impl522 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Sight__Group__0__Impl_in_rule__Sight__Group__0563 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Sight__Group__1_in_rule__Sight__Group__0566 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_14_in_rule__Sight__Group__0__Impl594 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Sight__Group__1__Impl_in_rule__Sight__Group__1625 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Sight__Group__2_in_rule__Sight__Group__1628 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Sight__NameAssignment_1_in_rule__Sight__Group__1__Impl655 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Sight__Group__2__Impl_in_rule__Sight__Group__2685 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Sight__DescriptionAssignment_2_in_rule__Sight__Group__2__Impl712 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCity_in_rule__Model__CitiesAssignment753 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_STRING_in_rule__City__NameAssignment_1784 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleSight_in_rule__City__SightsAssignment_3815 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_STRING_in_rule__Sight__NameAssignment_1846 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_STRING_in_rule__Sight__DescriptionAssignment_2877 = new BitSet(new long[]{0x0000000000000002L});

}